Index: /trunk/SophyaPI/PI/piimgtools.cc
===================================================================
--- /trunk/SophyaPI/PI/piimgtools.cc	(revision 3518)
+++ /trunk/SophyaPI/PI/piimgtools.cc	(revision 3519)
@@ -102,4 +102,5 @@
 mOpt[0]->AppendItem("Sqrt", 1102);
 mOpt[0]->AppendItem("Square", 1103);
+mOpt[0]->AppendItem("RGB", 1104);
 mOpt[0]->SetValue(1100);
 mOpt[0]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
@@ -190,11 +191,11 @@
 mOptzc[0]->AppendPDMenu(mCasc[1]);
 //  Apres les tables importees de MIDAS
-nsct4 = PIColorMap::NumberStandardColorMaps()-2; // Les reste jusqu'a l'avant derniere
+nsct4 = PIColorMap::NumberStandardColorMaps()-5; // Les reste jusqu'a l'avant derniere
 for(kcc=nsct3; kcc<nsct4; kcc++) 
   mCasc[2]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 mOptzc[0]->AppendPDMenu(mCasc[2]);
-// Les tables qui restent ( Col16 , ... )
+// Les tables qui restent ( RGB218, Col16 , ... )
 for(kcc=nsct4; kcc<PIColorMap::NumberStandardColorMaps(); kcc++) 
-mOptzc[0]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
+  mOptzc[0]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 // On ajoute un CheckItem pour inverser les index de table de couleur
 mOptzc[0]->Menu()->AppendSeparator();
@@ -373,4 +374,5 @@
   else if( (mpii->Lut())->Type() == kLutType_Sqrt )   mOpt[0]->SetValue(1102);
   else if( (mpii->Lut())->Type() == kLutType_Square ) mOpt[0]->SetValue(1103);
+  else if( (mpii->Lut())->Type() == kLutType_RGB )    mOpt[0]->SetValue(1104);
   else                                                mOpt[0]->SetValue(1100);
 }
@@ -388,5 +390,5 @@
 double min, max, del;
 int lauto, typ;
-int typlut[4] = {kLutType_Lin, kLutType_Log, kLutType_Sqrt, kLutType_Square} ; 
+int typlut[5] = {kLutType_Lin, kLutType_Log, kLutType_Sqrt, kLutType_Square, kLutType_RGB } ; 
 AutoLutType alts[13] = { AutoLut_No, 
 			 AutoLut_MeanSigma, AutoLut_MeanSigma, AutoLut_MeanSigma,
Index: /trunk/SophyaPI/PI/pipixmapgen.cc
===================================================================
--- /trunk/SophyaPI/PI/pipixmapgen.cc	(revision 3518)
+++ /trunk/SophyaPI/PI/pipixmapgen.cc	(revision 3519)
@@ -8,4 +8,5 @@
 #include "sopnamsp.h"
 #include "pipixmapgen.h"
+
 
 // --------- Methodes de la classe PIPixMap  ----------
@@ -43,7 +44,6 @@
 // long  kind() 
 //	Retourne le type ("=PIPixmap::ClassId")
-// void  SetPixmap(unsigned char *pix, int sx, int sy, bool refr=true, int ox=0, int oy=0)
-//	Associe un tableau d'index "pix" de taille "sx * sy".
-//	(ox,oy)" définissent  l'offset d'affichage.
+// void  SetPixmap(PIPixColIdx *pixidx, int sx, int sy, bool refr=true, int ox=0, int oy=0)
+//	Associe un tableau d'index de couleur "pixidx". (ox,oy)" définissent  l'offset d'affichage.
 //	Si "refr=true", la méthode "Refresh()" est appelée.
 //--
@@ -87,5 +87,5 @@
 {
 pixmap = NULL;
-nx = ny = 0;
+fgownpmap = false;
 ofx = ofy = 0;
 mPpos[0] = mPpos[0] = 0;
@@ -99,21 +99,41 @@
 {
 delete cmap;
+if (fgownpmap && pixmap) delete pixmap;
 }
 
 /* --Methode-- */
-void PIPixmapGen::SetPixmap(unsigned char *pix, int sx, int sy, bool refr, int ox, int oy)
+void PIPixmapGen::SetPixmap(PIPixColIdx *pixidx, bool refr, int ox, int oy)
 {
-pixmap = pix; 
-if (pixmap)
-  {
-  if (sx < 0)  sx = 0;
-  if (sy < 0)  sy = 0;
-  if (ox < 0)  ox = 0;
-  if (oy < 0)  oy = 0;
-  nx = sx; ny = sy;
-  ofx = ox;  ofy = oy;
+if (fgownpmap && pixmap) delete pixmap;
+fgownpmap = false;
+pixmap = pixidx; 
+if (ox < 0)  ox = 0;
+if (oy < 0)  oy = 0;
+ofx = ox;  ofy = oy;
+if (refr) Refresh();   
+}
+
+/* --Methode-- */
+void PIPixmapGen::SetRGBArray(PIPixRGBArray *rgba, CMapId cmapid, bool refr, int ox, int oy)
+{
+if (rgba == NULL) return;
+int quantum = 8;
+if (cmapid == CMAP_RGB216)  quantum = 6;
+else if (cmapid == CMAP_RGB4096) quantum = 16;
+else cmapid = CMAP_RGB512;
+SetColMapId(cmapid, false);
+PIPixColIdx * pixc = new PIPixColIdx;
+pixc->AllocateByte(rgba->XSize(), rgba->YSize());
+for(int j=0; j<rgba->YSize(); j++) 
+  for(int i=0; i<rgba->XSize(); i++) {
+  	PIPixRGB vv = (*rgba)(i,j);
+  	int r = (int)vv.red*quantum/256;
+  	int g = (int)vv.green*quantum/256;
+  	int b = (int)vv.blue*quantum/256;
+    pixc->GetShort(i,j) = (unsigned short)((b*quantum+g)*quantum+r);
   }
-else { ofx = ofy = nx = ny = 0; }
-if (refr) Refresh();   
+SetPixmap(pixc, refr, ox, oy);
+fgownpmap = true;
+return;  
 }
 
Index: /trunk/SophyaPI/PI/pipixmapgen.h
===================================================================
--- /trunk/SophyaPI/PI/pipixmapgen.h	(revision 3518)
+++ /trunk/SophyaPI/PI/pipixmapgen.h	(revision 3519)
@@ -9,5 +9,8 @@
 #include PICMAP_H
 
+#include "pipixutils.h"
+
 #include <list>
+
 
 class PIPixmapGen : public PIBaseWdg
@@ -22,6 +25,7 @@
   virtual long  kind() {return ClassId; }
 
-  virtual void  SetPixmap(unsigned char *pix, int sx, int sy, 
-                          bool refr=true, int ox=0, int oy=0);
+  virtual void  SetPixmap(PIPixColIdx *pixidx, bool refr=true, int ox=0, int oy=0);
+  virtual void  SetRGBArray(PIPixRGBArray *rgba, CMapId cmapid=CMAP_RGB512, 
+                            bool refr=true, int ox=0, int oy=0);
 
   virtual void  SetColMap(PIColorMap* cmp, bool refr=true);
@@ -39,7 +43,7 @@
 
 protected:
-  unsigned char *pixmap;
-  int nx, ny;
-  int ofx, ofy;
+  PIPixColIdx *pixmap;   // Pointeur d'objet PIPixCoIdx, tableau d'index de couleurs, peut etre NULL
+  bool fgownpmap;  // si true -> possede le pixmap et doit le deleter si besoin
+  int ofx, ofy;       // Offset d'affichage 
   PIColorMap* cmap;
 
Index: /trunk/SophyaPI/PI/pipixmapx.cc
===================================================================
--- /trunk/SophyaPI/PI/pipixmapx.cc	(revision 3518)
+++ /trunk/SophyaPI/PI/pipixmapx.cc	(revision 3519)
@@ -7,4 +7,6 @@
 #include "sopnamsp.h"
 #include "pipixmapx.h"
+#include <iostream>
+using namespace std;
 
 static  GC    mygc;
@@ -31,20 +33,37 @@
 {
 int i,j;
-unsigned char *pp;
-
-if (pixmap)
-  {
-  for(j=0; j<ny; j++)
-    {
-    pp = pixmap+j*nx;
-    for(i=0; i<nx; i++)
-      { XPutPixel(myximg, i, j, cmap->Color(*pp) );  pp++; }
+int nx = 0;
+int ny = 0;
+if (pixmap!=NULL) {
+  nx = pixmap->XSize();
+  if (nx > XSize())  nx = XSize();
+  ny = pixmap->YSize();
+  if (ny > YSize())  ny = YSize();
+  if (pixmap->BytePointer()!=NULL) {
+    unsigned char *pp = pixmap->BytePointer();
+    for(j=0; j<ny; j++) {
+      pp = pixmap->BytePointer()+j*pixmap->XSize();
+      for(i=0; i<nx; i++)
+        { XPutPixel(myximg, i, j, cmap->Color(*pp) );  pp++; }
+      }
+  }
+  else if (pixmap->ShortPointer()!=NULL) {
+    unsigned short *pp = pixmap->ShortPointer();
+    for(j=0; j<ny; j++) {
+      pp = pixmap->ShortPointer()+j*pixmap->XSize();
+      for(i=0; i<nx; i++)  
+        { XPutPixel(myximg, i, j, cmap->Color(*pp) );  pp++; }
     }
   }
-
+}
+/* ----- On peut laisser le reste - ce n'est pas utilise dans le Draw
+// On remplit le restant 
+for(j=0; j<YSize(); j++)
+  for(i=nx; i<XSize(); i++)
+       XPutPixel(myximg, i, j, 0 );
 for(j=ny; j<YSize(); j++)
-  for(i=nx; i<XSize(); i++)
+  for(i=0; i<XSize(); i++)
      XPutPixel(myximg, i, j, 0 );
-
+------- */
 PIBaseWdgX::Refresh();
 }
@@ -66,5 +85,5 @@
 if (!g) return; 
 if (g->kind() == PI_PSFileGraphics ) {
-    g->DrawPixmap(ofx, ofy, pixmap, nx, ny, cmap);
+    g->DrawPixmap(ofx, ofy, pixmap, cmap);
     //  Il faut faire quelque chose Sinon ??! 
   }
@@ -78,19 +97,26 @@
 
 if (!g) return; 
-if ((myximg == NULL) || (cmap == NULL)) return;
 
 if (g->kind() == PI_PSFileGraphics ) {
-  if (pixmap) g->DrawPixmap(ofx, ofy, pixmap, nx, ny, cmap);
+  g->DrawPixmap(ofx, ofy, (*pixmap), cmap);
   return;
   }
+  
 
 Window xw = XtWindow(XtWdg());
 Display * mdsp = PIXDisplay();
 
+if ((myximg == NULL) || (cmap == NULL) || (pixmap == NULL) ||
+    (pixmap->XSize()<=0) || (pixmap->YSize()<=0) ) {
+  XClearArea(mdsp, xw, x0, y0, dx, dy, False);  return; 
+}
+
 int mx, my, ox, oy;
 
 if (x0 < 0)  x0 = 0;
 if (y0 < 0)  y0 = 0;
-mx = nx+ofx;   my = ny+ofy;
+
+mx = pixmap->XSize()+ofx;   my = pixmap->YSize()+ofy;
+
 if (dx > (XSize()-x0)) dx = XSize()-x0;
 if (dy > (YSize()-y0)) dy = YSize()-y0;
@@ -101,5 +127,4 @@
 
 ox = oy = 0;  
-
 if (ofx > x0)
   { XClearArea(mdsp, xw, x0, y0, ofx-x0, dy, False);   
@@ -115,5 +140,26 @@
 if (my < (y0+dy))
   { XClearArea(mdsp, xw, x0, my, dx, y0+dy-my, False);  dy = my-y0; }
+
+/*
+if (ofx > x0)
+  XClearArea(mdsp, xw, x0, y0, ofx-x0, dy, False);   
+if (ofy > y0)
+  XClearArea(mdsp, xw, x0, y0, dx, ofy-y0, False);  
  
+if (mx < (x0+dx))
+  XClearArea(mdsp, xw, mx, y0, x0+dx-mx, dy, False); 
+if (my < (y0+dy))
+  XClearArea(mdsp, xw, x0, my, dx, y0+dy-my, False);  
+
+if (ofx > x0)
+  { dx -= (ofx-x0);  x0 = ofx;  ox = 0; }
+else  ox = x0-ofx;
+if (ofy > y0)
+  { dy -= (ofy-y0);  y0 = ofy;  oy = 0; }
+else  oy = y0-ofy;
+if (mx < (x0+dx))  dx = mx-x0;
+if (my < (y0+dy))  dy = my-y0;
+*/
+  
 XPutImage(mdsp, xw, mygc, myximg, ox, oy, x0, y0, dx, dy);
 XFlush(mdsp);
Index: /trunk/SophyaPI/PI/pipixutils.cc
===================================================================
--- /trunk/SophyaPI/PI/pipixutils.cc	(revision 3519)
+++ /trunk/SophyaPI/PI/pipixutils.cc	(revision 3519)
@@ -0,0 +1,108 @@
+// Module PI : Peida Interactive     PIPixmap
+// Classes utilitaires pour representation de pixels et couleurs RGB pour PI
+//                             R. Ansari  09/2008
+// LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
+
+#include <stdlib.h>
+#include <stdio.h>
+#include <iostream>
+using namespace std;
+
+#include "pipixutils.h"
+
+//++
+// Class	PIPixColIdx
+// Lib		PI
+// include	pipixmapgen.h
+//
+//   	Classe auxiliaire de gestion d'index de couleurs pour les pixmap,
+//	organise en interne en byte ou short.
+//--
+
+PIPixColIdx::PIPixColIdx()
+{
+  pix8 = NULL;
+  pix16 = NULL;
+  sx_ = sy_ = 0;
+}
+
+PIPixColIdx::~PIPixColIdx()
+{
+  if (pix8)  delete[] pix8;
+  if (pix16)  delete[] pix16;
+}
+
+void PIPixColIdx::AllocateByte(int sx, int sy)
+{
+  size_t osz = sx_*sy_;
+  if (sx<=0)  sx=sy=0;
+  else if (sy<=0)  sx=sy=0;
+  sx_ = sx; sy_ = sy; 
+  if (pix16)  delete[] pix16;
+  pix16 = NULL;
+  size_t nsz = sx_*sy_;
+  if (pix8) {
+    if (osz == nsz) return;
+    delete[] pix8;   pix8 = NULL;
+  }
+  if ((nsz > 0)&&(pix8==NULL)) {
+    pix8 = new unsigned char[nsz];
+  }
+}
+
+void PIPixColIdx::AllocateShort(int sx, int sy)
+{
+  size_t osz = sx_*sy_;
+  if (sx<=0)  sx=sy=0;
+  else if (sy<=0)  sx=sy=0;
+  sx_ = sx; sy_ = sy; 
+  if (pix8)  delete[] pix8;
+  pix8 = NULL;
+  size_t nsz = sx_*sy_;
+  if (pix16) {
+    if (osz == nsz) return;
+    delete[] pix16;   pix16 = NULL;
+  }
+  if ((nsz > 0)&&(pix16==NULL)) 
+    pix16 = new unsigned short[nsz];
+}
+
+
+//++
+// Class	PIPixRGBArray
+// Lib		PI
+// include	pipixmapgen.h
+//
+//   	Classe auxiliaire de gestion tableau representant des pixels RGB,
+//	chaque composante codee en 8 bits (unsigned char)
+//--
+
+PIPixRGBArray::PIPixRGBArray(int sx, int sy)
+{
+  if (sx < 0) sx = 0;
+  if (sy < 0) sy = 0;
+  sx_ = sx;  sy_ = sy;	
+  size_t sz = sx_*sy_;
+  if (sz>0) rgbpix_ = new PIPixRGB[sz];
+  else rgbpix_ = NULL;  
+}
+
+PIPixRGBArray::PIPixRGBArray(const char * filename)
+{
+  sx_ = sy_ = 0;
+  rgbpix_ = NULL; 
+  // lecture fichier a faire 	
+}
+
+PIPixRGBArray::~PIPixRGBArray()
+{
+  if (rgbpix_) delete[] rgbpix_;	
+}
+
+void PIPixRGBArray::SaveToFile(const char * filename)
+{
+  // ECRIRE fichier A FAIRE
+  return;	
+}
+
+
Index: /trunk/SophyaPI/PI/pipixutils.h
===================================================================
--- /trunk/SophyaPI/PI/pipixutils.h	(revision 3519)
+++ /trunk/SophyaPI/PI/pipixutils.h	(revision 3519)
@@ -0,0 +1,82 @@
+// This may look like C code, but it is really -*- C++ -*-
+// Classes utilitaires pour representation de pixels et couleurs RGB pour PI
+//                             R. Ansari  09/2008
+// LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
+
+#ifndef PIPIXUTILS_H_SEEN
+#define PIPIXUTILS_H_SEEN
+
+// =======  Classes utilitaires pour PIPixmap / PIImage =====
+// 
+// Definition d'un tableau pour gerer des index de couleurs en 8 bits / 16 bits
+// 
+class PIPixColIdx 
+{
+public:
+  PIPixColIdx();
+  ~PIPixColIdx();
+  inline int XSize() { return sx_; }
+  inline int YSize() { return sy_; }
+
+  void AllocateByte(int sx, int sy);
+  void AllocateShort(int sx, int sy);
+  inline void DeAlloc() { AllocateByte(0,0); }
+
+  inline unsigned char GetByte(int i, int j) const 
+    { return pix8[j*sx_+i]; }
+  inline unsigned char & GetByte(int i, int j)  
+    { return pix8[j*sx_+i]; }
+
+  inline unsigned short GetShort(int i, int j) const 
+    { return pix16[j*sx_+i]; }
+  inline unsigned short & GetShort(int i, int j)  
+    { return pix16[j*sx_+i]; }
+    
+  inline unsigned char* BytePointer() { return pix8; }
+  inline unsigned short* ShortPointer() { return pix16; }
+
+protected:
+  unsigned char * pix8;
+  unsigned short * pix16;
+  int sx_, sy_;
+};
+
+
+// 
+// Definition de pixel et tableau de pixel RGB de 8 bits (byte)
+// 
+
+// Cette structure DOIT avoir la taille d'un entier de 4 bytes
+struct PIPixRGB {
+  unsigned char red;
+  unsigned char green;
+  unsigned char blue;
+  unsigned char alpha;  // non utilise pour le moment 	
+};
+ 
+class PIPixRGBArray
+{
+public:	
+  PIPixRGBArray(int sx, int sy);
+  PIPixRGBArray(const char * filename);
+  ~PIPixRGBArray();
+  
+  inline int XSize() { return sx_; }
+  inline int YSize() { return sy_; }
+
+  inline PIPixRGB operator()(int i, int j) const
+    { return rgbpix_[j*sx_+i]; }
+  inline PIPixRGB& operator()(int i, int j) 
+    { return rgbpix_[j*sx_+i]; }
+ 
+  void SaveToFile(const char * filename);
+    
+protected:
+  PIPixRGB * rgbpix_;  
+  int sx_, sy_;  
+};
+
+
+#endif   /* PIPIXUTILS_H_SEEN */
+
+
Index: /trunk/SophyaPI/PI/psfile.cc
===================================================================
--- /trunk/SophyaPI/PI/psfile.cc	(revision 3518)
+++ /trunk/SophyaPI/PI/psfile.cc	(revision 3519)
@@ -1367,6 +1367,46 @@
     for(i = 0; i < Ny; i++) {
 	for(j = 0; j<Nx-1; j++ )
-	    fprintf(mPSFile, "%02X", Pict[i*Nx+j]);
-    fprintf(mPSFile, "%02X\n", Pict[i*Nx+j]);
+	    fprintf(mPSFile, "%02X", (int)Pict[i*Nx+j]);
+    fprintf(mPSFile, "%02X\n", (int)Pict[i*Nx+j]);
+    }
+    /* Un petit grestore ...*/
+    fprintf(mPSFile, "gr\n");
+}
+
+void PSFile::Image(double x0, double y0, double Tx, double Ty,
+		   int Nx, int Ny,
+		   unsigned short *Pict, 
+		   PIColorMap *mMap) {
+
+    int i, j;
+
+    /* Buffers PostScript */
+    fprintf(mPSFile, "/Taille %d def\n", Nx);
+    fprintf(mPSFile, "/ImStr Taille string def\n");
+    fprintf(mPSFile, "/RGBStr Taille 3  mul string def\n");
+
+    /* Ecriture ColorMap */
+    fprintf(mPSFile, "/ColorMap %05d array def\n", mMap->NCol() );
+    for(i = 0; i < mMap->NCol(); i++) {
+	fprintf(mPSFile, "ColorMap %d [16#%02X 16#%02X 16#%02X] put\n",
+		i,
+		(int)(mMap->GetColor(i).red/256),
+		(int)(mMap->GetColor(i).green/256),
+		(int)(mMap->GetColor(i).blue/256));
+    }
+    /* Emplacement de l'image */
+    fprintf(mPSFile, "gs %.2f Ux %.2f Uy tr %.2f Ux %.2f Uy sc\n", x0, y0, Tx, Ty);
+    /* Nbr pix-X, Nbr pix-Y bits/pixels */
+    fprintf(mPSFile, "%d %d 16\n", Nx, Ny);
+    /* Matrice de passage */
+    fprintf(mPSFile, "[%d 0 0 %d 0 0]", Nx, Ny);
+    /* Fonction colorimage */
+    fprintf(mPSFile, "{currentfile ImStr readhexstring pop GetRGB}\
+false 3 colorimage\n\n");
+    /* Data */
+    for(i = 0; i < Ny; i++) {
+	for(j = 0; j<Nx-1; j++ )
+	    fprintf(mPSFile, "%04X", (int)Pict[i*Nx+j]);
+    fprintf(mPSFile, "%04X\n", (int)Pict[i*Nx+j]);
     }
     /* Un petit grestore ...*/
Index: /trunk/SophyaPI/PI/psfile.h
===================================================================
--- /trunk/SophyaPI/PI/psfile.h	(revision 3518)
+++ /trunk/SophyaPI/PI/psfile.h	(revision 3519)
@@ -165,4 +165,8 @@
 			unsigned char *pict,
 			PIColorMap *mColorMap);
+    virtual void  Image(double x0, double y0, double Tx, double Ty,
+			int Nx, int Ny,
+			unsigned short *pict,
+			PIColorMap *mColorMap);
 
 // Declarations en public - sinon certains compilateurs cxx , aCC, xlC ont des problemes
